<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

    <title>Running Environments</title>
    <meta name="description" content="ESTP 2023 course, day 1: Running Environments">
    <meta name="author" content="Ole Mussmann">

    <link rel="icon" type="image/x-icon" href="./files/favicon-32x32.png">

    <meta name="apple-mobile-web-app-capable" content="yes">
    <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">

    <meta name="viewport" content="width=device-width, initial-scale=1.0">

    <link rel="stylesheet" href="dist/reset.css">
    <link rel="stylesheet" href="dist/reveal.css">

    <!-- theme -->
    <link rel="stylesheet" href="dist/theme/black.css" id="theme">
    <link rel="stylesheet" href="dist/theme/escience_4.3.1.css" id="theme">

    <!-- fonts -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Nunito">
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Assistant">
    <link rel="stylesheet" href="https://fonts.googleapis.com/icon?family=Material+Icons">

    <!-- Theme used for syntax highlighted code -->
    <link rel="stylesheet" href="plugin/highlight/monokai.css">

    <!-- Load jQuery -->
    <script
      src="https://code.jquery.com/jquery-3.4.1.min.js"
      integrity="sha256-CSXorXvZcTkaix6Yvo6HppcZGetbYMGWSFlBw8HfCJo="
      crossorigin="anonymous"></script>
    <script src="http://localhost:35729/livereload.js"></script>

  </head>
  <body>
    <div class="reveal">
      <div class="slides">

        <section data-markdown data-state="blue_overlay yellow_flag yellow_strip purple_half_circle_bottom purple_blob right_e_top" data-background="./files/man-4800810_1920.jpg">
          <textarea data-template>
<!-- https://pixabay.com/photos/man-runner-running-fitness-canal-4800810/ -->

<h1 style="margin: 0; padding:0; padding-right: 20%;">Running</h1>
<h1 style="margin: 0; padding:0; padding-left: 15%;">Environments</h1>

<br>
<br>

<div>
  <a href="mailto:o.mussmann@esciencecenter.nl">Ole Mussmann</a> | <a href="https://www.esciencecenter.nl/">eScience Center</a> | <img style="height: 2.5vw; padding: 0 .5vw; margin-bottom: -.5vw; margin-top: -2vw;" src="./files/eu_logo.png"><img style="height: 2vw; margin-bottom: -.5vw; margin-top: -2vw;" src="./files/logo_icon.jpg">
</div>

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/checklist-2589418_1920.jpg">
<!-- https://pixabay.com/photos/checklist-goals-box-notebook-pen-2589418/ -->
<textarea data-template>

## Table of Contents

- [Scripts, REPL, Notebooks](#/repl)
- [Google Colab](#/colab)
- [💻 Colab Exercise](#/exercise_colab)
- [Renkulab](#/renkulab)
- [MyBinder](#/binder)
- [Bonus: Docker](#/docker)
- [Summary](#/summary)
- [Links](#/links)
- [💻 Renku Exercise](#/exercise_renku)
- [💻 Binder Exercise](#/exercise_binder)

</textarea>
</section>

<section data-markdown data-state="logo yellow_flag purple_overlay" data-background="./files/journal-2850091_1920.jpg" id="repl">
<!-- https://pixabay.com/photos/journal-write-blank-pages-notes-2850091/ -->
<textarea data-template>

# Scripts, REPL, Notebooks

- Scripts
  - Files that contain code
  - Run once
- REPL: Read, Eval, Print, Loop
  - Read a line, evaluate, print result, repeat
  - Keep variables in memory, explore interactively
- Notebooks
  - Based on files, but REPL in execution
  - Hybrid between scripts and REPL

Notes:
Show python script hello world

Show python REPL hello world

Notebooks you will explore yourself

</textarea>
</section>
<section>
<section data-markdown data-state="standard" data-background="./files/teamwork-3213924_1920.jpg" id="colab">
<!-- https://pixabay.com/photos/teamwork-cooperation-brainstorming-3213924/ -->
<textarea data-template>

# Google Colab
## Notebooks in the Google Cloud

<br>

https://colab.research.google.com

</textarea>
</section>
<section data-markdown data-state="standard" data-background="./files/teamwork-3213924_1920.jpg">
<!-- .slide: data-state="standard" data-background="./files/teamwork-3213924_1920.jpg" -->
<!-- https://pixabay.com/photos/teamwork-cooperation-brainstorming-3213924/ -->
<textarea data-template>

## Colab benefits

- No installation, runs anywhere
- Google ecosystem
  - Sharing is easy
  - Files stored in Google Drive
- Good defaults
- Useful widgets
- Revision history
- Free GPU and TPU
- Collaboration possible 😉

</textarea>
</section>
<section data-markdown data-state="standard" data-background="./files/teamwork-3213924_1920.jpg">
<!-- https://pixabay.com/photos/teamwork-cooperation-brainstorming-3213924/ -->
<textarea data-template>

## Colab drawbacks

- Account needed
- Vendor lock-in
- How long will it last?
- No CPU/RAM choices
- No long-running jobs
- Does not work offline
- Data "in the cloud" (GDPR?)
- Installed packages not preserved
- Real-time collaboration was removed

</textarea>
</section>
<section data-markdown data-state="logo yellow_flag black_overlay 6" data-background="./files/man-2264825_1920.jpg" id="exercise_colab">
<!-- https://pixabay.com/photos/man-woman-push-ups-wellness-2264825/ -->
<textarea data-template>

# Exercise Colab

</textarea>
</section>
<section data-markdown data-state="logo yellow_flag black_overlay 6" data-background="./files/man-2264825_1920.jpg">
<textarea data-template>
<!-- https://pixabay.com/photos/man-woman-push-ups-wellness-2264825/ -->

### First steps with Colab

<!-- Don't remove the trailing whitespace, it's important for formatting -->

<div style="font-size: large;">

1. Create a Google account (or use your existing one)  
   Log in at https://colab.research.google.com  

2. Explore Examples  
   File → Open Notebook → Examples  
   - Overview of Colaboratory Features
   - Markdown Guide
   - Charts in Colaboratory
   - Altair Chart Snippets
   - Accessing files
   - Google Drive Snippets

3. Create a visualization with Graphviz in Colab   
   https://h1ros.github.io/posts/introduction-to-graphviz-in-jupyter-notebook/  

4. Plot with Altair  
   Upload this data file to your Google Drive: [data.csv](data.csv)  
   (Upload via file browser on the left if you encounter upload errors)  
   Load it into a Pandas DataFrame in Colab  
   Line-plot it with Altair https://altair-viz.github.io/gallery/simple_line_chart.html   
</div>

</textarea>
</section>
</section>

<section>
<section data-markdown data-state="logo yellow_flag white_overlay 9" data-background="./files/renkulab_logo.svg" id="renkulab" data-background-size="contain">
<textarea data-template>

# Renkulab
## Open Source Notebooks for Data Scientists

<br>

https://renkulab.io

</textarea>
</section>
<section data-markdown data-state="logo yellow_flag white_overlay 9" data-background="./files/renkulab_logo.svg" data-background-size="contain">
<textarea data-template>

## Renkulab benefits

- No installation, runs anywhere
- *Pipeline for reproducible data science*
- Sane default setup
- Hardware choices (CPU/RAM)
- Custom Docker images possible
- [Live collaboration possible](https://jupyterlab.readthedocs.io/en/stable/user/rtc.html)
- No vendor lock-in
  - [renku](https://github.com/SwissDataScienceCenter/renku) is available under [Apache 2.0](https://www.apache.org/licenses/LICENSE-2.0.html)
  - Local installation possible
- Own GitLab backend
  - Git integration in JupyterLab already set up

</textarea>
</section>

<section data-markdown data-state="logo yellow_flag white_overlay 9" data-background="./files/renkulab_logo.svg" data-background-size="contain">
<textarea data-template>

## Renkulab drawbacks

- Account needed
- Limited hardware choices (CPU/RAM)
  - and no GPU, TPU
- Does not work offline
  - ... but you can install it locally!
- Data "in the cloud" (GDPR?)
  - ... if you use the cloud

</textarea>
</section>
<section data-markdown data-state="logo yellow_flag black_overlay 6" data-background="./files/man-2264825_1920.jpg" id="exercise_renku">
<!-- https://pixabay.com/photos/man-woman-push-ups-wellness-2264825/ -->
<textarea data-template>

# Exercise Renkulab


</textarea>
</section>
<section data-markdown data-state="logo yellow_flag black_overlay 6" data-background="./files/man-2264825_1920.jpg">
<textarea data-template>
<!-- https://pixabay.com/photos/man-woman-push-ups-wellness-2264825/ -->

### Renkulab Pipeline

<!-- Don't remove the trailing whitespace, it's important for formatting -->

<div style="font-size: x-large;">

1. Create a Renku account (or use GitHub)  
   https://renkulab.io/login  

2. Follow the Renku tutorial  
   https://renku.readthedocs.io/en/latest/tutorials/01_firststeps.html  
   - "Start with Options": let's be nice, "medium" &amp; 1GB storage is sufficient
   - Use JupyterLab (/lab) or RStudio (/rstudio), use Python or R
   - Tomorrow we will learn about the `git` commands and GitLab workflow!
   - Please read everything before you execute commands. Some commands are repeated to showcase different approaches.
     - E.g.: Choose *either* "Adding data from a remote repository" *or* "Adding data from the local file system"
   - Use `pandas` version `2.2.2` ⚠️
   - The paths are not always correct ⚠️
     - Within "Building scripts" → "Organizing scripts within your project", do _not_ use julia/python/r subfolders. Put the script directly in src/ .
</div>

Notes:
You don't need to understand the git part (yet), same with the GitLab workflows.

</textarea>
</section>
</section>

<section>
<section data-markdown data-state="logo yellow_flag white_overlay 9" data-background="https://mybinder.org/static/logo.svg" id="binder" data-background-size="contain">
<textarea data-template>

# Mybinder
## Git to Notebook in Seconds

<br>

https://mybinder.org/


</textarea>
</section>
<section data-markdown data-state="logo yellow_flag white_overlay 9" data-background="https://mybinder.org/static/logo.svg" data-background-size="contain">
<textarea data-template>

## Mybinder benefits

- No installation, runs anywhere
- No account needed
- Custom Docker images possible
- [Live collaboration possible](https://jupyterlab.readthedocs.io/en/stable/user/rtc.html)
- Start from a badge in your README.md
- Decouple JupyterLab config from code repo
- Many sources: GitHub, GitLab, Zenodo, Figshare, ...
- No vendor lock-in
  - [binderhub](https://github.com/jupyterhub/binderhub) is available under [BSD 3-Clause License](https://opensource.org/licenses/BSD-3-Clause)
  - Local installation possible

</textarea>
</section>
<section data-markdown data-state="logo yellow_flag white_overlay 9" data-background="https://mybinder.org/static/logo.svg" data-background-size="contain">
<textarea data-template>

## Mybinder drawbacks

- Barebone default setup
- Starting sometimes takes a while
- No collaboration outside of source repo
- No hardware choices and no GPU, TPU
- Only for "public" data
  - ... unless you roll your own binder
- Does not work offline
  - ... but you can install it locally!

</textarea>
</section>
<section data-markdown data-state="logo yellow_flag black_overlay 6" data-background="./files/man-2264825_1920.jpg" id="exercise_binder">
<!-- https://pixabay.com/photos/man-woman-push-ups-wellness-2264825/ -->
<textarea data-template>

# Exercise Mybinder

</textarea>
</section>
<section data-markdown data-state="logo yellow_flag black_overlay 6" data-background="./files/man-2264825_1920.jpg">
<textarea data-template>
<!-- https://pixabay.com/photos/man-woman-push-ups-wellness-2264825/ -->

### Zero to Mybinder

<!-- Don't remove the trailing whitespace, it's important for formatting -->

<div style="font-size: x-large;">

1. Create a **public** repository on GitHub or GitLab  
   - Create a "Hello World" script in the **main** branch  
   - Python works out-of-the-box, Julia and R need additional steps:
     - https://the-turing-way.netlify.app/communication/binder/zero-to-binder.html

2. Go to https://mybinder.org/  
   - Choose your repo type in the dropdown ⚠️
   - Paste your repo URL
   - For a one-off binder: click **launch** 
   - For a permanent binder
      - Expand the binder badge menu, paste the markdown line in your README.md
      - Commit the README.md to your **main** branch
     - Click on the **binder** badge in your repo

3. Open a terminal in JupyterLab   
   - Run your "Hello World" script in the terminal   
</div>

Note:
Show how to make new files on github (poem repo)

</textarea>
</section>
<section data-markdown data-state="logo yellow_flag black_overlay 6" data-background="./files/man-2264825_1920.jpg">
<textarea data-template>
<!-- https://pixabay.com/photos/man-woman-push-ups-wellness-2264825/ -->

### Advanced Mybinder

<!-- Don't remove the trailing whitespace, it's important for formatting -->

<div style="font-size: x-large;">

1. Add packages to your environment, follow  
   - https://the-turing-way.netlify.app/communication/binder/zero-to-binder.html#pinning-dependencies  

2. Create a new notebook in JupyterLab (for example on [renkulab.io](https://renkulab.io))   
   - Write a short demo using a package you installed in step 1., e.g. numpy
   - Download the notebook to your PC
   - Upload it to your repo
   - Binderize the repo, add the badge to your README.md
   - Share your badge link 🙂
3. Explore other interfaces and learn how to add data  
   - https://the-turing-way.netlify.app/communication/binder/zero-to-binder.html#changing-the-interface
   - https://the-turing-way.netlify.app/communication/binder/zero-to-binder.html#get-data-with-postbuild
</div>

</textarea>
</section>
</section>

<section>
<section data-markdown data-state="logo yellow_flag blue_overlay" data-background="./files/port-1845350_1920.jpg" id="docker">
<!-- https://pixabay.com/photos/port-pier-cargo-containers-crate-1845350/ -->
<textarea data-template>

# Bonus: Docker
## Off-the-shelf Environments

</textarea>
</section>
<section data-markdown data-state="logo yellow_flag blue_overlay" data-background="./files/port-1845350_1920.jpg">
<textarea data-template>
<!-- https://pixabay.com/photos/port-pier-cargo-containers-crate-1845350/ -->

## Installation

- *Desktop* (GUI) for larger enterprises is a paid service ⚠️
  - Free for companies with &lt;250 employees AND less than $10&nbsp;million in annual revenue<sup>[1]</sup>
- *Server* (CLI) is free

- [Install](https://docs.docker.com/engine/install/) *Server* for Linux
  - or on Windows via [Windows Subsystem for Linux](https://ubuntu.com/wsl)
    - https://dev.solita.fi/2021/12/21/docker-on-wsl2-without-docker-desktop.html
    - https://dev.to/bowmanjd/install-docker-on-windows-wsl-without-docker-desktop-34m9

<footer>[1] as of 2024-06-03 <a href="https://www.docker.com/pricing/">docker.com/pricing/</a></footer>


</textarea>
</section>
<section data-markdown data-state="logo yellow_flag blue_overlay" data-background="./files/port-1845350_1920.jpg" data-auto-animate>
<textarea data-template>
<!-- https://pixabay.com/photos/port-pier-cargo-containers-crate-1845350/ -->

## Usage


- Create a notebook directory

<pre data-id="code-animation"><code data-trim data-line-numbers>
  mkdir notebooks
</code></pre>

</textarea>
</section>
<section data-markdown data-state="logo yellow_flag blue_overlay" data-background="./files/port-1845350_1920.jpg" data-auto-animate>
<textarea data-template>
<!-- https://pixabay.com/photos/port-pier-cargo-containers-crate-1845350/ -->

## Usage

- Create a notebook directory
- Run a container, and ...

<pre data-id="code-animation"><code data-trim data-line-numbers="2-3">
  mkdir notebooks
  docker run \
    jupyter/scipy-notebook
</code></pre>

</textarea>
</section>
<section data-markdown data-state="logo yellow_flag blue_overlay" data-background="./files/port-1845350_1920.jpg" data-auto-animate>
<textarea data-template>
<!-- https://pixabay.com/photos/port-pier-cargo-containers-crate-1845350/ -->

## Usage

- Create a notebook directory
- Run a container, and ...
- Expose a port, so you can use it on your host system

<pre data-id="code-animation"><code data-trim data-line-numbers="3">
  mkdir notebooks
  docker run \
    -p 8888:8888 \
    jupyter/scipy-notebook
</code></pre>

source:destination

</textarea>
</section>
<section data-markdown data-state="logo yellow_flag blue_overlay" data-background="./files/port-1845350_1920.jpg" data-auto-animate>
<textarea data-template>
<!-- https://pixabay.com/photos/port-pier-cargo-containers-crate-1845350/ -->

## Usage

- Create a notebook directory
- Run a container, and ...
- Expose a port, so you can use it on your host system
- Mount the 'notebook' folder in the container

<pre data-id="code-animation"><code data-trim data-line-numbers="4">
  mkdir notebooks
  docker run \
    -p 8888:8888 \
    -v $(pwd)/notebooks:/home/jovyan/work \
    jupyter/scipy-notebook
</code></pre>

source:destination


</textarea>
</section>
<section data-markdown data-state="logo yellow_flag blue_overlay" data-background="./files/port-1845350_1920.jpg" data-auto-animate>
<textarea data-template>
<!-- https://pixabay.com/photos/port-pier-cargo-containers-crate-1845350/ -->

## Usage

- Create a notebook directory
- Run a container, and ...
- Expose a port, so you can use it on your host system
- Mount the 'notebook' folder in the container
- Throw away the container after it stops (optional)

<pre data-id="code-animation"><code data-trim data-line-numbers="3">
  mkdir notebooks
  docker run \
    --rm \
    -p 8888:8888 \
    -v $(pwd)/notebooks:/home/jovyan/work \
    jupyter/scipy-notebook
</code></pre>

</textarea>
</section>
<section data-markdown data-state="logo yellow_flag blue_overlay" data-background="./files/port-1845350_1920.jpg" data-auto-animate>
<textarea data-template>
<!-- https://pixabay.com/photos/port-pier-cargo-containers-crate-1845350/ -->

## Usage

- Create a notebook directory
- Run a container, and ...
- Expose a port, so you can use it on your host system
- Mount the 'notebook' folder in the container
- Throw away the container after it stops (optional)
- Find many useful containers at https://hub.docker.com

<pre data-id="code-animation"><code data-trim data-line-numbers=>
  mkdir notebooks
  docker run \
    --rm \
    -p 8888:8888 \
    -v $(pwd)/notebooks:/home/jovyan/work \
    jupyter/scipy-notebook
</code></pre>

</textarea>
</section>
<section data-markdown data-state="logo yellow_flag blue_overlay" data-background="./files/port-1845350_1920.jpg">
<textarea data-template>
<!-- https://pixabay.com/photos/port-pier-cargo-containers-crate-1845350/ -->

## Official Jupyter images

- Use them as-is
- Or create your own using them as a parent
- Create a curated candy-shop of available environments
- Integrate with renkulab or mybinder

https://jupyter-docker-stacks.readthedocs.io/en/latest/using/selecting.html

</textarea>
</section>
</section>

<section>
<section data-state="standard 4" data-background="./files/note-pad-1215425_1920.jpg" id="summary">
<!-- https://pixabay.com/illustrations/note-pad-pen-coffee-cup-plant-1215425/ -->

<div style="transform: rotate(-5deg); width: 72%; float: left; margin-left: 2vw;">
<h2>Summary</h2>
<ul>
  <li>Many options for installation-free running environments</li>
  <li>Be careful with sensitive data</li>
  <li>Colab</li>
  <ul>
    <li>Content <b>creation</b>, collaboration</li>
  </ul>
  <li>Renkulab</li>
  <ul>
    <li>Content <b>creation</b>, reproducible pipeline</li>
  </ul>
  <li>MyBinder</li>
  <ul>
    <li>Content <b>distribution</b>, very accessible</li>
  </ul>
</ul>
</div>

</section>
</section>

<section>
<section data-markdown data-state="logo yellow_flag black_overlay" data-background="./files/earth-3537401_1920.jpg" id="links">
<!-- https://pixabay.com/illustrations/earth-network-blockchain-globe-3537401/ -->
<textarea data-template>

# Resources

- https://colab.research.google.com
- https://renkulab.io
  - https://renku.readthedocs.io
- https://mybinder.org
  - https://the-turing-way.netlify.app/communication/binder/zero-to-binder.html
- [I don't like notebooks](https://docs.google.com/presentation/d/1n2RlMdmv1p25Xy5thJUhkKGvjtV-dkAIsUXP-AL4ffI/edit#slide=id.g362da58057_0_1) (I actually do, but it has some valid gotcha's)

</textarea>
</section>
      </div>
    </div>

    <script src="dist/reveal.js"></script>

    <script src="plugin/highlight/highlight.js"></script>
    <script src="plugin/markdown/markdown.js"></script>
    <script src="plugin/math/math.js"></script>
    <script src="plugin/notes/notes.js"></script>
    <script src="plugin/search/search.js"></script>
    <script src="plugin/zoom/zoom.js"></script>
    <!--
    <script src="reveal.js/4.3.1/reveal.js-plugins/menu/menu.js"></script>
    -->

    <script src="dist/escience.js"></script>

    <script>
      // More info about initialization & config:
      // - https://revealjs.com/initialization/
      // - https://revealjs.com/config/
      Reveal.initialize({
        hash: true,

        // Automatically activate the scroll view when we the viewport falls
        // below the given width.
        scrollActivationWidth: 0,  // disabled

        // Force the scrollbar to remain visible
        scrollProgress: true,

        // Learn about plugins: https://revealjs.com/plugins/
        plugins: [ RevealMarkdown, RevealHighlight, RevealNotes ]
      });
    </script>
  </body>
</html>
